/**
 * @brief Breve description...
 *
 * Descripcion detallada...
 * @file pointers.c
 * @author Gil Perez, Borja (bor.gil@predoc.uam.es)
 * @version 1.0
 * @date 2018-01-26 (yyyy-mm-dd)
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "const.h"
#include "pointers.h"

/* No es necesario comentar las funciones para Doxygen.
 * No es necesario describir las funciones ni sus argumentos,
 * esa tarea ya se realiza en el archivo de cabecera */
int ej1(char c) {
	/* Dentro de las funciones tampoco es necesario utilizar comentarios para Doxygen */
    char *pc = NULL;

    fprintf(stdout, "----- ej1 -----\n");
    fprintf(stdout, "ANTES\t\tc =\t%c\t&c = %p\n", c, &c);
    pc = &c;
    fprintf(stdout, "ANTES\t\t*pc =\t%c\tpc = %p\t&pc = %p\n", *pc, pc, (void *)&pc);
    *pc += 2;
    fprintf(stdout, "DESPUES\t\tc =\t%c\t&c = %p\n", c, &c);
    fprintf(stdout, "DESPUES\t\t*pc =\t%c\tpc = %p\t&pc = %p\n", *pc, pc, (void *)&pc);

    return OK;
}

int ej2(char *pc) {
    fprintf(stdout, "----- ej2 -----\n");
    fprintf(stdout, "ANTES\t\t*pc =\t%c\tpc = %p\t&pc = %p\n", *pc, pc, (void *)&pc);
    *pc += 2;
    fprintf(stdout, "DESPUES\t\t*pc =\t%c\tpc = %p\t&pc = %p\n", *pc, pc, (void *)&pc);

    return OK;
}

int ej3(char *ac) {
    const char tac[] = "Psicologia cognitivo-conductual";

    fprintf(stdout, "----- ej3 -----\n");
    fprintf(stdout, "ANTES\t\tac = %p\t%s\n", ac, ac);
    ac = (char *)malloc((strlen(tac) + 1) * sizeof(char));
    strcpy(ac, tac);
    fprintf(stdout, "DESPUES\t\tac = %p\t\t%s\n", ac, ac);

    /* Ejecuta con Valgrind el codigo con la siguiente instruccion comentada y descomentada */
    /*free(ac);*/

    return OK;
}

int ej4(char *ac) {
    fprintf(stdout, "----- ej4 -----\n");
    fprintf(stdout, "ANTES\t\tac = %p\t%s\n", ac, ac);
    strcpy(ac, "Psicologia cognitivo-conductual");
    fprintf(stdout, "DESPUES\t\tac = %p\t%s\n", ac, ac);

    return OK;
}

int ej5(int *ai, char *ac) {
    fprintf(stdout, "----- ej5 -----\n");
    fprintf(stdout, "\t\tac = %p\n\t\tai = %p\n", ac, (void *)ai);
    fprintf(stdout, "\t\tai[5] =\t\t\t%d\n", ai[5]);
    fprintf(stdout, "\t\tac + 5 =\t\t%s\n", ac + 5);
    fprintf(stdout, "\t\tac[18] = %c\t\t\tequivale a\t*(ac + 18) = %c\n", ac[18], *(ac + 18));
    fprintf(stdout, "\t\t&(ai[18]) = %p\tequivale a\tai + 18 = %p\n", (void *)&(ai[18]), (void *)(ai+18));

    return OK;
}

int ej6(char *ac) {
    fprintf(stdout, "----- ej6 -----\n");
    fprintf(stdout, "\t\tac = %p\t\t\tsizeof(ac) = %ld Byte(s)\n", ac, sizeof(ac));
    fprintf(stdout, "\t\tac = %s\tstrlen(ac) = %ld caracteres\n", ac, strlen(ac));
    fprintf(stdout, "\t\tsizeof(ac[0]) = %ld Byte(s)\tequivale a\tsizeof(char) = %ld Byte(s)\n", sizeof(ac[0]), sizeof(char));
    fprintf(stdout, "\t\tstrlen(ac) * sizeof(char) =\t\t%ld Byte(s)\n", strlen(ac) * sizeof(char));
    fprintf(stdout, "\n\tRazon de sumar 1 cuando se reserva memoria con malloc para dar espacio a '\\0',\npor ejemplo ejecutando (char *)malloc((strlen(ac) +1) * sizeof(char)) :\n");
    fprintf(stdout, "\t\t'\\0' como char = %c, no imprime nada\tsizeof((char)'\\0') = %ld Byte(s)\n", '\0', sizeof((char)'\0'));
    fprintf(stdout, "\t\t'\\0' como direccion de memoria = %p\tsizeof((void *)'\\0') = %ld Byte(s)\n", (void *)'\0', sizeof((void *)'\0'));
    fprintf(stdout, "\tRespuesta: '\\0' como caracter ocupa 1 Byte(s) pero lo mas fino sería cambiar ese +1 por sizeof(char) o sizeof((char)'\\0'), que lo normal es que sea 1 Byte(s)... Pero y si no es asi en algun dispositivo?\n");

    return OK;
}
